# Интеллектуальные информационные системы

## Лекции

| Дата       |Лекция | 
| :---:      | :---  | 
| 05.09.2023 | [Вводная лекция](lectures/IIS_lec_1.pdf) [pptx](lectures/IIS_lec_1.pptx) |
| 13.09.2023 | [Файловая система HDFS](lectures/IIS_lec_2.pdf) [pptx](lectures/IIS_lec_2.pptx) |  
| 19.09.2023 | [MapReduce](lectures/IIS_lec_3.pdf) [pptx](lectures/IIS_lec_3.pptx) |  
| 26.09.2023 | [Решение задач MapReduce](lectures/IIS_lec_4.pdf) [pptx](lectures/IIS_lec_4.pptx) | 
| 03.10.2023 | [Решение задач MapReduce - tf-idf](lectures/IIS_lec_5.pdf) [pptx](lectures/IIS_lec_5.pptx) |  
| 10.10.2023 | [Работа с графами](lectures/IIS_lec_6.pdf) [pptx](lectures/IIS_lec_6.pptx) |  
| 17.10.2023 | [Работа с графами. PageRank](lectures/IIS_lec_7.pdf) [pptx](lectures/IIS_lec_7.pptx) |  
| 24.10.2023 | [Apache Pig](lectures/IIS_lec_8.pdf) [pptx](lectures/IIS_lec_8.pptx) | 
| 31.10.2023 | [Apache Pig – решение задач](lectures/IIS_lec_9.pdf) [pptx](lectures/IIS_lec_9.pptx) | 
| 14.11.2023 | [Apache Hive](lectures/IIS_lec_10.pdf) [pptx](lectures/IIS_lec_10.pptx) | 

## Лабораторные работы

* Лабораторная работа №1 [Знакомство с Hadoop](labs/lab01.md)   
* Лабораторная работа №2 [Алгоритмы MapReduce](labs/lab02.md)  
* Лабораторная работа №3 [Знакомство с инструментами Pig и Hive](labs/lab03.md) 